#include <iostream>
#include "algorithm.hpp"

using namespace std;

int main(){

	bool flip = false;
	char c;
	mpz_class n,d;
	rat r0( 0, 0 ), r1, q, one( 1, 1 ), half( 1, 2 );
	leaf mu_p, range;

//***** Setup and fetching of mu_p *********************************************

	cout<<"This program takes p and calculates the equivalent mating"<<endl
			<<"to s_{3/7} mated with s_p\n";

	range.set_a( 1, 7 );
	range.set_b( 2, 7 );

	// 	Get mu_p.a ------------------------------------------------------------------
	while( mu_p.get_a().get_denom() == 0 ){
		cout<<"\nPlease enter the first endpoint of \\mu_p: ";
		cin>>n>>c>>d;

		mu_p.set_a( n, d );

		if( mu_p.get_a().get_denom() != 0 ){
			if( ( mu_p.get_a() < range.get_a() ) || ( mu_p.get_a() > range.get_b() ) ){
				cout<<mu_p.get_a()<<" is not in the valid range ("<<range<<").\n";
				mu_p.set_a( 0, 0 );
			}
		}
	}

	// 	Get mu_p.b ------------------------------------------------------------------
	while( mu_p.get_b().get_denom() == 0 ){
		cout<<"Please enter the second endpoint of \\mu_p: ";
		cin>>n>>c>>d;

		mu_p.set_b( n, d );

		if( mu_p.get_b().get_denom() != 0 ){
			if( ( mu_p.get_b() < range.get_a() ) || ( mu_p.get_b() > range.get_b() ) ){
				cout<<mu_p.get_b()<<" is not in the valid range ("<<range<<").\n";
				mu_p.set_b( 0, 0 );
			}
		}
	}

	n = 0;
	while( n == 0 ){
		cout << "\nHow many full periods of the tableau would you like to ";
		cout << "calculate?: ";
		cin >> n;
		if( n < 0 )
			cout<<"Try again.";
	}

	if( mu_p.get_a() > mu_p.get_b() ) flip = true;

	if( algorithm( mu_p, true, n.get_ui(), flip ).get_a().get_denom() == 0 )
		return 1;

	return 0;
}
