#include <iostream>
#include <string.h>
#include <math.h>
#include <gmpxx.h>
#include <Board.h>
#include "../shared/classes.cpp"
#include "../shared/calc_leaf.hpp"

main(){

    char fname[50], c;
    rat e1, e2, f1, f2;
    int i, j;
    mpz_class ull_n = 1, ull_d = 0;
	Board b;

    // Choose filename and create file
    cout << "Choose filename (<10 characters): ";
    cin >> fname;

    // write main circle to file
    // write header to file and close
	b.setLineWidth( 0.5 ).setPenColorRGBi( 0, 0, 0 ).drawCircle( 300, 300, 250, 0 );

    // Get initial leaf
	cout << "\nFirst endpoint of leaf: ";
	cin >> ull_n >> c >> ull_d;
	e1.set_num( ull_n );
	e1.set_denom( ull_d );
	cout << "Second endpoint of leaf: ";
	cin >> ull_n >> c >> ull_d;
	e2.set_num( ull_n );
	e2.set_denom( ull_d );
	cout << e1.get_num() << "/" << e1.get_denom() << " -> " << e2.get_num() << "/" << e2.get_denom();

	//How many iterations?
	cout << "\n\nHow many forward images of this leaf should be drawn? ";
	cin >> i;

// Group calc_leaf( rat alpha, rat beta, int centreX = 300, int centreY = 300,int radius = 250, short int depth = -1, Color colour = Color::Red, float linewidth = 0.5, bool label_endpoints = false ){
// Group calc_leaf_outside( rat A, rat B, int centre_x = 300, int centre_y = 300, int radius = 250, short int depth = -1, Color colour = Color::Red, float linewidth = 0.5, bool label_endpoints = false ){
	#ifndef OUTSIDE
		b << calc_leaf( e1, e2, 300, 300, 250, -1, Color::Red, 0.5, true );
	#else
		b << calc_leaf_outside( e1, e2, 300, 300, 250, -1, Color::Red, 0.5, true );
	#endif
	//negative leaves
	f2.set_rat( 1, 2 );
	f1 = e1 + f2;
	f2 = e2 + f2;
	#ifndef OUTSIDE
		b << calc_leaf( f1, f2, 300, 300, 250, -1, Color::Blue );
	#else
		b << calc_leaf_outside( f1, f2, 300, 300, 250, -1, Color::Blue );
	#endif

	for( j = 1; j <= i; ++j ){
		e1 = e1 * 2;
		e2 = e2 * 2;
		#ifndef OUTSIDE
			b << calc_leaf( e1, e2 );
		#else
			b << calc_leaf_outside( e1, e2 );
		#endif
       	//negative leaves
		f2.set_rat( 1, 2 );
       	f1 = e1 + f2;
       	f2 = e2 + f2;
		#ifndef OUTSIDE
			b << calc_leaf( f1, f2, 300, 300, 250, -1, Color::Blue );
		#else
			b << calc_leaf_outside( f1, f2, 300, 300, 250, -1, Color::Blue );
		#endif
	}

	#ifndef EPS
	    strcat( fname, ".svg" );
		b.saveSVG( fname );
	#else
	    strcat( fname, ".eps" );
		b.saveEPS( fname );
	#endif
}
