#include <iostream>
#include <Board.h>

using namespace LibBoard;
using namespace std;

int main(){

	float angle = M_PI / 5;

	Line l1( -60, 0, 60, 0, Color::Black, 1, Shape::ButtCap, Shape::MiterJoin, -2 );
	Line l2 = l1.rotated( angle );
	Line l3 = l2.rotated( angle );
	Line l4 = l3.rotated( angle );
	Line l5 = l4.rotated( angle );
	Arc a1( 0, 0, M_PI / 5, M_PI * 2 / 5, 10, 20, Color::Green, Color::None, 1, 1 );
	Arc a2( 0, 0, M_PI / 5, M_PI * 3 / 5, 12, 24, Color::Red, Color::None, 1 );
	Arc a3( 0, 0, M_PI / 5, M_PI * 4 / 5, 14, 28, Color::Blue, Color::None, 1 );
	Arc a4( 0, 0, M_PI / 5, M_PI, 16, 32, Color::Green, Color::None, 1 );
	Arc a5( 0, 0, M_PI / 5, M_PI * 6 / 5, 18, 36, Color::Yellow, Color::None, 1 );
	Arc a6( 0, 0, M_PI / 5, M_PI * 7 / 5, 20, 40, Color::Red, Color::None, 1 );
	Arc a7( 0, 0, M_PI / 5, M_PI * 8 / 5, 22, 44, Color::Blue, Color::None, 1 );
	Arc a8( 0, 0, M_PI / 5, M_PI * 9 / 5, 24, 48, Color::Green, Color::None, 1 );
	Arc a9( 0, 0, M_PI / 5, M_PI * 2, 26, 52, Color::Yellow, Color::None, 1 );
	Arc a10( 0, 0, M_PI / 5, M_PI * 11 / 5, 28, 56, Color::Red, Color::None, 1 );
	Board b;

	b << l1 << l2 << l3 << l4 << l5;
	b << a1 << a2 << a3 << a4 << a5 << a6 << a7 << a8 << a9 << a10;

	b.translate( 100, 0 );

	b << l1.rotate( angle );
	b << l2.rotate( angle );
	b << l3.rotate( angle );
	b << l4.rotate( angle );
	b << l5.rotate( angle );
	b << a1.rotate( angle );
	b << a2.rotate( angle );
	b << a3.rotate( angle );
	b << a4.rotate( angle );
	b << a5.rotate( angle );
	b << a6.rotate( angle );
	b << a7.rotate( angle );
	b << a8.rotate( angle );
	b << a9.rotate( angle );
	b << a10.rotate( angle );
	b << l1 << l2 << l3 << l4 << l5;
	b << a1 << a2 << a3 << a4 << a5 << a6 << a7 << a8 << a9 << a10;

	b.translate( 100, 0 );

	cout << "Scaling...\n";
	b << l1.scale( 1, 0.5 );
	b << l2.scale( 1, 0.5 );
	b << l3.scale( 1, 0.5 );
	b << l4.scale( 1, 0.5 );
	b << l5.scale( 1, 0.5 );
	b << a1.scale( 1, 0.5 );
	b << a2.scale( 1, 0.5 );
	b << a3.scale( 1, 0.5 );
	b << a4.scale( 1, 0.5 );
	b << a5.scale( 1, 0.5 );
	b << a6.scale( 1, 0.5 );
	b << a7.scale( 1, 0.5 );
	b << a8.scale( 1, 0.5 );
	b << a9.scale( 1, 0.5 );
	b << a10.scale( 1, 0.5 );
	b << l1 << l2 << l3 << l4 << l5;
	b << a1 << a2 << a3 << a4 << a5 << a6 << a7 << a8 << a9 << a10;

	b.saveEPS( "image.eps" );
	b.saveFIG( "image.fig" );
	b.saveSVG( "image.svg" );

}
