#include <iostream>
#include <fstream>
#include <Board.h>
#include "../shared/leaf_helpers.hpp"
#include "../shared/calc_leaf.hpp"

using namespace std;

int to_pow(int n,int e);

// mpz_mul_2exp( mpz_t out, mpz_t coeff, lon unsigned int exp)
// out = coeff x 2^exp

// for keeping track of which pull back was taken
const char given = 1;
const char given_plus_half = 2;

int main()
{
	Board b;
	leaf major;
	rat half( 1, 2 );
	rat end1, end2;
	int n, limit = 0, period = 0;
	int i, placer = 1, last_start = 0, last_end = 0, pre_image_no = 0;
	char c;

	// Get major leaf
	cout << "Enter one endpoint of the major leaf: ";
	cin >> end1;
	cout << "Enter the second endpoint: ";
	cin >> end2;
	major.set_leaf( end1, end2 );

	// Get leaf to take pre-images from
	cout << "\nEnter one endpoint of the leaf of which you wish to find pre-images: ";
	cin >> end1;
	cout << "Enter the second endpoint: ";
	cin >> end2;

	// How many pre-images?
	cout << "\nHow many levels of pre-images do you want to find: ";
	cin >> n;

	#ifdef PRE_VERBOSE
		cout << "\n\nFind " << n << " pre-images of (" << end1 << " - " << end2 << ")" << endl;
	#endif

	// Initialise array
	#ifdef PRE_DEBUG
		cout<<"Calculating req. size of Array..." << endl;
	#endif
	for( i = 0; i <= n; ++i ){
		limit = limit + to_pow( 2, i );
		#ifdef PRE_DEBUG
			cout<< "\tn = " << n << ", i = " << i << ", limit = " << limit << endl;
		#endif
	}

	// Declare variable dependent on limit
	#ifdef PRE_DEBUG
		cout<<"Creating Array of size " << limit << "..." << endl;
	#endif
	leaf pre_images[ limit ];

	// Enter loop to find pre-images
	#ifdef PRE_DEBUG
		cout<< "Setting first leaf..." << endl;
	#endif
	pre_images[ 0 ].set_leaf( end1, end2 );

	// check for periodicity (need to remove duplicates in this case)
	#ifdef PRE_DEBUG
		cout<<"Checking for periodicity..." << endl;
	#endif
	end1.simplify();
	end2.simplify();
	// endpoints are odd then may be periodic
	if ( end1.get_denom() % 2 == 1 && end2.get_denom() % 2 == 1 ) {
		for( i = 1; i < min( end1.get_denom(), end2.get_denom() ); ++i ){
			end1 = end1 * 2;
			end1.simplify();
			end2 = end2 * 2;
			end2.simplify();
			if ( ( end1 == pre_images[ 0 ].get_a() && end2 == pre_images[ 0 ].get_b() ) || ( end1 == pre_images[ 0 ].get_b() && end2 == pre_images[ 0 ].get_a() ) ) {
				period = i;
				i = max( end1.get_denom().get_si(), end2.get_denom().get_si() );
			}
		}
	}

	#ifdef PRE_VERBOSE
		cout << "\nStarting while loop..." << endl;
	#endif

	#ifdef PRE_DEBUG
		cout << "Pre-Debug: number of leaves = " << limit << endl;
	#endif
	while( pre_image_no++ < n ){	// each loop is one set of pre-images
		#ifdef PERIODIC_DEBUG
			cout << "pre-image level " << pre_image_no
				<< ", period " << period << endl;
		#endif
		#ifdef PRE_DEBUG
			cout << "Pre-Debug: last_start = " << last_start << endl;
			cout << "Pre-Debug: last_end = " << last_end << endl;
		#endif
		for( i = last_start; i <= last_end; ++i ){
			#ifdef PRE_DEBUG
				cout << "Pre-Debug: for_loop: placer = " << placer << endl;
			#endif
			pre_images[ placer ] = get_preimage( pre_images[ i ], major );
			#ifdef PRE_DEBUG
				cout << "Pre-Debug: for_loop: pre-image of " << pre_images[ i ] << " is " << pre_images[ placer ] << endl;
				cout << "Pre-Debug: for_loop: placer = " << placer << endl;
			#endif
			pre_images[ placer + 1 ] = pre_images[ placer ] + half;
			placer += 2;
			#ifdef PRE_DEBUG
				cout << "Pre-Debug: for_loop: " << pre_images[ placer - 2 ] << " + " << half << " is " << pre_images[ placer - 1 ] << " ( " << pre_images[ placer - 2 ] + half << " ) " << endl;
				cout << "Pre-Debug: for_loop: placer = " << placer << endl;
			#endif

			// draw new leaves
			if ( pre_image_no != period ){ // if not periodic (period == 0) or initial leaf does not exist in this set of pre-images
				#ifdef OUTSIDE
					b << calc_leaf_outside( pre_images[ placer - 1 ].get_a(), pre_images[ placer - 1 ].get_b() );
					b << calc_leaf_outside( pre_images[ placer - 2 ].get_a(), pre_images[ placer - 2 ].get_b() );
				#else
					b << calc_leaf( pre_images[ placer - 1 ].get_a(), pre_images[ placer - 1 ].get_b() );
					b << calc_leaf( pre_images[ placer - 2 ].get_a(), pre_images[ placer - 2 ].get_b() );
				#endif
			} else {
				// if pre_images[ placer - ? ] not a copy of the initial leaf then draw
				if ( pre_images[ placer - 2 ] != pre_images[ 0 ] ) {
					#ifdef OUTSIDE
						b << calc_leaf_outside( pre_images[ placer - 2 ].get_a(), pre_images[ placer - 2 ].get_b() );
					#else
						b << calc_leaf( pre_images[ placer - 2 ].get_a(), pre_images[ placer - 2 ].get_b() );
					#endif
				} else {
					// if it IS a copy then remove from pre_images and decrease relavant counters
					#ifdef PERIODIC_DEBUG
						cout << "Leaf cancelled: pre-image level " << pre_image_no
							<< ", period " << period << endl;
					#endif
					pre_images[ placer - 2 ] = pre_images[ placer - 1 ];
					--placer;
				}
				if ( pre_images[ placer - 1 ] != pre_images[ 0 ] ) {
					#ifdef OUTSIDE
						b << calc_leaf_outside( pre_images[ placer - 1 ].get_a(), pre_images[ placer - 1 ].get_b() );
					#else
						b << calc_leaf( pre_images[ placer - 1 ].get_a(), pre_images[ placer - 1 ].get_b() );
					#endif
				} else {
					// if it IS a copy then remove from pre_images and decrease relavant counters
					#ifdef PERIODIC_DEBUG
						cout << "Leaf cancelled: pre-image level " << pre_image_no
							<< ", period " << period << endl;
					#endif
					--placer;
				}
			}
		}
		last_start = last_end + 1;
		last_end = placer - 1;
	}

	#ifdef OUTSIDE
		b << calc_leaf_outside( pre_images[ 0 ].get_a(), pre_images[ 0 ].get_b(), 300, 300, 250, -1, Color::Blue, 0.5, true );
	#else
		b << calc_leaf( pre_images[ 0 ].get_a(), pre_images[ 0 ].get_b(), 300, 300, 250, -1, Color::Blue, 0.5, true );
	#endif

	// draw circle
	b.setLineWidth( 1 ).setPenColorRGBi( 0, 0, 0 ).drawCircle( 300, 300, 250, 0 );

	// Output pre-images
	#ifndef EPS
		#ifdef OUTSIDE
			 b.saveSVG( "lamination-out.svg" );
		#else
			 b.saveSVG( "lamination.svg" );
		#endif
	#else
		#ifdef OUTSIDE
			 b.saveEPS( "lamination-out.eps" );
		#else
			 b.saveEPS( "lamination.eps" );
		#endif
	#endif

    return 0;
}

//--------------------------

int to_pow( int n, int e ){

    int i, r = 1;

    for( i = e; i > 0; i-- )
        r *= n;

    return r;

}
