#include <iostream>
#include <fstream>
#include <string>
#include <sys/stat.h>
#include <gmpxx.h>
#include "../shared/classes.cpp"
#include "../shared/ml.hpp"
#include "../shared/alg_file.hpp"

using namespace std;

int main() {

	unsigned short n=0;
	string filename;
	struct stat sb;
	mpz_class num=0, count, x, y;
	rat p, q;

	cout << "Please enter the period of the leaves you wish to find:\n";
	cin >> n;

	// set filename
	x = n;
	filename = "qml_p";
	if( x < 10 )
		filename = filename + '0';
	filename = filename + x.get_str() + ".txt";

	if( !stat( filename.c_str(), &sb ) ){
		cout << "file " << filename << " exists." << endl;
		return 1;
	}

	// set count
	mpz_ui_pow_ui( count.get_mpz_t(), 2, n );
	count = count - 1;

	bool used[ count.get_ui() - 1 ];
	for( ; num < count - 1; ++ num ){
		used[ num.get_ui() ] = false;
	}

	#ifdef DEBUG
		cout << "count = " << count << endl;
		for( x = 0; x < count - 1; ++x ){
			if( used[ x.get_ui() ] == true )
				cout << "1 ";
			else
				cout << "0 ";
		}
		cout << endl;
	#endif

	// main loop
	for( num = 0; num < count - 1; ++num ){
		if( !used[ num.get_ui() ] ){
			p.set_rat( num + 1, count );
			p.simplify();
			// check if p is of lower period
			y = 1;
			if( ( x = p.get_denom() ) != count ){
				x = x + 1;
				while( y < x )
					y = y * 2;
			}
			if( x != y ){
				// p not of lower period
				q = find_minor( p );

				// normalise p & q
				x = count / q.get_denom();
				q.set_num( q.get_num() * x );
				q.set_denom( q.get_denom() * x );
				x = count / p.get_denom();
				p.set_num( p.get_num() * x );
				p.set_denom( p.get_denom() * x );

				// set used
				used[ num.get_ui() ] = true;
				used[ q.get_num().get_ui() - 1 ] = true;

				// write to file
				put_leaf( p, q, filename, 1 );
			} else {
				used[ num.get_ui() ] = true;
			}
		}
	#ifdef DEBUG
		cout << "count = " << count << ", num = " << num << endl;
		for( x = 0; x < count - 1; ++x ){
			if( used[ x.get_ui() ] == true )
				cout << "1 ";
			else
				cout << "0 ";
		}
		cout << endl;
	#endif
	}

	return 0;
}
