#include <Board.h>
#include <sys/stat.h>
#include "../shared/calc_leaf.hpp"
#include "../shared/classes.cpp"
#include "../shared/alg_file.hpp"

using namespace std;
using namespace LibBoard;

int main()
{

	int i = 2, j = 0;
	struct stat sb;
	string filename_qml;
	mpz_class x;
	leaf l, EOFL;
	Board b;

	x = 2;
    filename_qml = "qml_p";
    if( x < 10 ){
        filename_qml = filename_qml + '0';
    }
    filename_qml = filename_qml + x.get_str() + ".txt";

	// one cycle of while loop per period
	while( !stat( filename_qml.c_str(), &sb ) ){

		cout << "Adding leaves of period " << i << " from file "
			<< filename_qml << ".\n";

		Group g;
		j = 0;

		while( ( l = get_leaf( filename_qml, j++, 1, i ) ) != EOFL ){
			// write leaf
			g << calc_leaf( l.get_a(), l.get_b(), 300, 300, 250, 0, Color::Black );
		}

		// calculate next filename
		x = ++i;
	    filename_qml = "qml_p";
	    if( x < 10 ){
	        filename_qml = filename_qml + '0';
	    }
	    filename_qml = filename_qml + x.get_str() + ".txt";

		// write layer
		b << g;
	}

	cout << "File " << filename_qml << " does not exist.\n"
		<< "Stopping at period " << i << ".\n";

    #ifndef EPS
        b.saveSVG( "qml.svg" );
    #else
        b.saveEPS( "qml.eps" );
    #endif

}
