#include <iostream>
#include <gmpxx.h>
#include "classes.cpp"
#include "leaf_helpers.hpp"

using namespace std;

int to_pow( int n, int e ){

    int i, r = 1;

    for( i = e; i > 0; i-- )
        r *= n;

    return r;

}

//---------------------------------------------------------------------

rat find_minor( const rat & p, const int & period ) {

	rat q( 0, 0 );
	if ( period == 0 )
		return q;

	int i = 1;
	rat half( 1, 2 );
	leaf temp;
	leaf diam_orbit[ period ];

	// calc forward orbit of p
	diam_orbit[ 0 ].set_a( p );
	for( ; i < period; ++i )
		diam_orbit[ i ].set_a( diam_orbit[ i - 1 ].get_a() * 2 );

	// pull back diameter
	diam_orbit[ period - 1 ].set_b( diam_orbit[ period - 1 ].get_a() + half );
	for( i = period - 2; i >= 0; --i ) {
		temp = get_preimage( diam_orbit[ i + 1 ], diam_orbit[ period - 1 ] );
		if ( temp.get_a() == diam_orbit[ i ].get_a() )
			diam_orbit[ i ].set_b( temp.get_b() );
		else if ( temp.get_b() == diam_orbit[ i ].get_a() )
			diam_orbit[ i ].set_b( temp.get_a() );
		else {
			temp = temp + half;
			if ( temp.get_a() == diam_orbit[ i ].get_a() )
				diam_orbit[ i ].set_b( temp.get_b() );
			else if ( temp.get_b() == diam_orbit[ i ].get_a() )
				diam_orbit[ i ].set_b( temp.get_a() );
			else {
				cout << "find_minor(): pull back of diamter doesn't match forward orbit of p." << endl;
				cout << "\tpulling back " << diam_orbit[ i + 1 ]
					<< "\n\treceived " << temp << " and " << temp + half
					<< "\n\tto have " << diam_orbit[ i ].get_a()
					<< " as endpoint.\n\tperiod = " << period << endl;
				for( i = 0; i < period; ++ i)
					cout << "\t" << i << ": " << diam_orbit[ i ].get_a() << endl;
				return q;
			}
		}
	}

	#ifdef ML_DEBUG
		cout << "\np = " << p << "\nperiod = " << period << endl;
		for( i = 0; i < period; ++ i)
			cout << i << ": " << diam_orbit[ i ] << endl;
	#endif

	q = diam_orbit[ 0 ].get_b();

	if ( q > p ) {
		q = p + ( rat( to_pow( 2, period ), to_pow( 2, period ) - 1 ) * ( q - p ) );
	} else {
		q = p - ( rat( to_pow( 2, period ), to_pow( 2, period ) - 1 ) * ( p - q ) );
	}

	return q;
}

//---------------------------------------------------------------------

rat find_minor( rat p ) {

	int period = 0;

	p.simplify();

	if ( p.get_denom() % 2 != 1 )
		return find_minor( p, period ); // pass period == 0

	// find period
	while( ( to_pow( 2, ++period ) - 1 ) % p.get_denom() != 0 );

	return find_minor( p, period );

}
